Ruby - Bug #20213

zsuper with keyword splat without explicit keywords incorrectly uses mutable keyword splat
01/25/2024 09:49 PM - jeremyevans0 (Jeremy Evans)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: Backport: 3.0: DONTNEED, 3.1: DONTNEED, 3.2:
DONTNEED, 3.3: DONE

Description
As the subject states, the super call in this code is compiled incorrectly:

extend (Module.new{def a(**k) k[:a] = 1 end})
extend (Module.new{def a(**k) p k; super; p k end})
a

# Expected output, actual output on Ruby 2.0-3.2:
{}
{}

# Actual output on Ruby 3.3 and master
{}
{:a=>1}

The zsuper call here uses VM_CALL_KW_SPLAT_MUT:

invokesuper <calldata'argc:1, FCALL|SUPER|ZSUPER|KW_SPLAT|KW_SPLAT_MUT>
, nil

That is not correct, because as the example shows, if the super method accepts a keyword splat, the super method can modify the
keyword splat, and changes are reflected in the caller.

| submitted a pull request to fix this: https:/github.com/ruby/ruby/pull/9710, and marked this for backporting to 3.3.

Associated revisions

Revision 69ceeb6fee50f63cd52d59325dc3780a6fc4e5ae2 - 03/20/2024 11:05 AM - NARUSE, Yui
merge revision(s) 771a2f039b9a059a73e8f111d1d46590fa697f63: [Backport #20213] (#10297)

Fix incorrect use of VM_CALL_KW_SPLAT_MUT in zsuper with keyword splat

For zsuper calls with a keyword splat but no actual keywords, the
keyword splat is passed directly, so it cannot be mutable, because
if the callee accepts a keyword splat, changes to the keyword splat
by the callee would be reflected in the caller.

While here, simplify the logic when the method supports

literal keywords. I don't think it is possible for

a method with has_kw param flags to not have keywords, so add an
assertion for that, and set VM_CALL_KW_SPLAT_MUT in a single place.

Revision 69ceeb6fee50f63cd52d59325dc3780a6fc4e5ae2 - 03/20/2024 11:05 AM - NARUSE, Yui
merge revision(s) 771a2f039b9a059a73e8f111d1d46590fa697f63: [Backport #20213] (#10297)
Fix incorrect use of VM_CALL_KW_SPLAT_MUT in zsuper with keyword splat
For zsuper calls with a keyword splat but no actual keywords, the
keyword splat is passed directly, so it cannot be mutable, because
if the callee accepts a keyword splat, changes to the keyword splat

by the callee would be reflected in the caller.

While here, simplify the logic when the method supports
literal keywords. I don't think it is possible for
a method with has_kw param flags to not have keywords, so add an
assertion for that, and set VM_CALL_KW_SPLAT_MUT in a single place.

Revision 69cee6fe - 03/20/2024 11:05 AM - NARUSE, Yui
merge revision(s) 771a2f039b9a059a73e8f111d1d46590fa697f63: [Backport #20213] (#10297)

Fix incorrect use of VM_CALL_KW_SPLAT_MUT in zsuper with keyword splat

For zsuper calls with a keyword splat but no actual keywords, the
keyword splat is passed directly, so it cannot be mutable, because
if the callee accepts a keyword splat, changes to the keyword splat
by the callee would be reflected in the caller.

While here, simplify the logic when the method supports

literal keywords. I don't think it is possible for

a method with has_kw param flags to not have keywords, so add an
assertion for that, and set VM_CALL_KW_SPLAT_MUT in a single place.

History

#1 - 01/26/2024 04:54 AM - jeremyevans0 (Jeremy Evans)
- Status changed from Open to Closed

Fixed by 771a2f039b9a059a73e8f111d1d46590fa69763

#2 - 03/20/2024 12:48 PM - naruse (Yui NARUSE)
- Backport changed from 3.0: DONTNEED, 3.1: DONTNEED, 3.2: DONTNEED, 3.3: REQUIRED to 3.0: DONTNEED, 3.1: DONTNEED, 3.2:
DONTNEED, 3.3: DONE

ruby_3_3 69ceebfee50f63cd52d59325dc3780a6fc4e5ae2 merged revision(s) 771a2f039b9a059a73e8f111d1d46590fa697f63.
